## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.10

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XalanDeque Class Template Reference

Xalan implementation of deque. More...

`#include <XalanDeque.hpp>`

List of all members.

## Public Types

- typedef size_t size_type
- typedef Type value_type
- typedef Type& reference
- typedef const Type& const_reference
- typedef XalanVector<Type,
  ConstructionTraits> BlockType
- typedef XalanVector<BlockType*> BlockIndexType
- typedef XalanDeque<Type, ConstructionTraits> ThisType
- typedef XalanDequeIterator<
  XalanDequeIteratorTraits<value_type>,
  ThisType> iterator
- typedef XalanDequeIterator<
  XalanDequeConstIteratorTraits<
  value_type>, ThisType> const_iterator
- typedef XALAN_STD_QUALIFIER
  reverse_iterator<iterator,
  value_type> reverse_iterator_
- typedef XALAN_STD_QUALIFIER
  reverse_iterator<const_iterator,
  value_type, const_reference> const_reverse_iterator_
- typedef reverse_iterator_ reverse_iterator
- typedef const_reverse_iterator_ const_reverse_iterator

## Public Methods

- XalanDeque (MemoryManagerType &memoryManager, size_type initialSize=0, size_type blockSize=10)
- XalanDeque (const XalanDeque &theRhs, MemoryManagerType &memoryManager)
- ~XalanDeque ()
- iterator begin ()
- const_iterator begin () const
- iterator end ()
- const_iterator end () const
- const_reverse_iterator rbegin () const
- const_reverse_iterator rend () const
- bool empty () const
- size_type size () const
- value_type& back ()
- value_type& operator[] (size_type index)
- const value_type& operator[] (size_type index) const
- void clear ()
- void push_back (const value_type &value)
- void pop_back ()
- void resize (size_type newSize)
- void swap (XalanDeque &theRhs)
- XalanDeque& operator= (const XalanDeque &theRhs)
- MemoryManagerType& getMemoryManager ()

## Static Public Methods

- XalanDeque* create (MemoryManagerType &theManager, size_type initialSize=0, size_type blockSize=10)

## Protected Methods

- BlockType* getNewBlock ()
- BlockType* allocate (size_type size)
- void deallocate (BlockType *pointer)

## Protected Attributes

- MemoryManagerType* m_memoryManager
- const size_type m_blockSize
- BlockIndexType m_blockIndex
- BlockIndexType m_freeBlockVector

## Detailed Description

### template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>> class XalanDeque

Xalan implementation of deque.

## Member Typedef Documentation

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef XalanVector< BlockType *> XalanDeque<Type, ConstructionTraits>::BlockIndexType<BlockType*>

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef XalanVector< Type, ConstructionTraits > XalanDeque<Type, ConstructionTraits>::BlockType<Type, ConstructionTraits>

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef XalanDeque< Type, ConstructionTraits > XalanDeque<Type, ConstructionTraits>::ThisType<Type, ConstructionTraits>

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef XalanDequeIterator< XalanDequeConstIteratorTraits< value_type >, ThisType > XalanDeque<Type, ConstructionTraits>::const_iterator<XalanDequeConstIteratorTraits<value_type>, ThisType>

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef const Type & XalanDeque<Type, ConstructionTraits>::const_reference

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef const_reverse_iterator_ XalanDeque<Type, ConstructionTraits>::const_reverse_iterator

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef XALAN_STD_QUALIFIER reverse_iterator< const_iterator, value_type, const_reference > XalanDeque<Type, ConstructionTraits>::const_reverse_iterator_<const_iterator, value_type, const_reference>

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef XalanDequeIterator< XalanDequeIteratorTraits< value_type >, ThisType > XalanDeque<Type, ConstructionTraits>::iterator<XalanDequeIteratorTraits<value_type>, ThisType>

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef Type & XalanDeque<Type, ConstructionTraits>::reference

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef reverse_iterator_ XalanDeque<Type, ConstructionTraits>::reverse_iterator

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef XALAN_STD_QUALIFIER reverse_iterator< iterator, value_type > XalanDeque<Type, ConstructionTraits>::reverse_iterator_<iterator, value_type>

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef size_t XalanDeque<Type, ConstructionTraits>::size_type

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
typedef Type XalanDeque<Type, ConstructionTraits>::value_type

## Constructor & Destructor Documentation

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
XalanDeque<Type, ConstructionTraits>::XalanDeque<Type, ConstructionTraits> ( | MemoryManagerType & memoryManager,
| size_type initialSize = 0,
| size_type blockSize = 10 )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
XalanDeque<Type, ConstructionTraits>::XalanDeque<Type, ConstructionTraits> ( | const XalanDeque<Type, ConstructionTraits> & theRhs,
| MemoryManagerType & memoryManager )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
XalanDeque<Type, ConstructionTraits>::~XalanDeque<Type, ConstructionTraits> ( | )

## Member Function Documentation

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
BlockType * XalanDeque<Type, ConstructionTraits>::allocate ( | size_type size )`[protected]`

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
value_type & XalanDeque<Type, ConstructionTraits>::back ( | )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
const_iterator XalanDeque<Type, ConstructionTraits>::begin ( | ) const

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
iterator XalanDeque<Type, ConstructionTraits>::begin ( | )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
void XalanDeque<Type, ConstructionTraits>::clear ( | )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
XalanDeque<Type, ConstructionTraits> * XalanDeque<Type, ConstructionTraits>::create ( | MemoryManagerType & theManager,
| size_type initialSize = 0,
| size_type blockSize = 10 )`[static]`

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
void XalanDeque<Type, ConstructionTraits>::deallocate ( | BlockType * pointer )`[protected]`

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
bool XalanDeque<Type, ConstructionTraits>::empty ( | ) const

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
const_iterator XalanDeque<Type, ConstructionTraits>::end ( | ) const

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
iterator XalanDeque<Type, ConstructionTraits>::end ( | )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
MemoryManagerType & XalanDeque<Type, ConstructionTraits>::getMemoryManager ( | )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
BlockType * XalanDeque<Type, ConstructionTraits>::getNewBlock ( | )`[protected]`

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
XalanDeque<Type, ConstructionTraits> & XalanDeque<Type, ConstructionTraits>::operator= ( | const XalanDeque<Type, ConstructionTraits> & theRhs )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
const value_type & XalanDeque<Type, ConstructionTraits>::operator[] ( | size_type index ) const

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
value_type & XalanDeque<Type, ConstructionTraits>::operator[] ( | size_type index )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
void XalanDeque<Type, ConstructionTraits>::pop_back ( | )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
void XalanDeque<Type, ConstructionTraits>::push_back ( | const value_type & value )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
const_reverse_iterator XalanDeque<Type, ConstructionTraits>::rbegin ( | ) const

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
const_reverse_iterator XalanDeque<Type, ConstructionTraits>::rend ( | ) const

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
void XalanDeque<Type, ConstructionTraits>::resize ( | size_type newSize )

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
size_type XalanDeque<Type, ConstructionTraits>::size ( | ) const

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
void XalanDeque<Type, ConstructionTraits>::swap ( | XalanDeque<Type, ConstructionTraits> & theRhs )

## Member Data Documentation

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
BlockIndexType XalanDeque<Type, ConstructionTraits>::m_blockIndex`[protected]`

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
const size_type XalanDeque<Type, ConstructionTraits>::m_blockSize`[protected]`

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
BlockIndexType XalanDeque<Type, ConstructionTraits>::m_freeBlockVector`[protected]`

template<class Type, class ConstructionTraits = MemoryManagedConstructionTraits<Type>>
MemoryManagerType * XalanDeque<Type, ConstructionTraits>::m_memoryManager`[protected]`

The documentation for this class was generated from the following file:

- XalanDeque.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.10 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.